<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

namespace Kufer\KuferTools\Firma\MitarbeiterUebersicht\MitarbeiterDokumente;

class MitarbeiterDokumenteUebersichtPresenter extends \Kufer\KuferTools\Basis\Presenter\MitRahmenPresenter
{
  protected function getView()
  {
    return new MitarbeiterDokumenteUebersichtView($this->getViewModel());
  }

  protected function getViewModel()
  {
    $viewModel = new MitarbeiterDokumenteUebersichtViewModel();
    $viewModel->teilnehmer = $this->useCaseResponse->teilnehmer;
    $viewModel->dokumente = $this->useCaseResponse->dokumente;
    $viewModel->showUploadButton = $this->useCaseResponse->showUploadButton;

    return $viewModel;
  }

  protected function getContent()
  {
    $view = $this->getView();

    $result = '';
    $result .= $view->getHeader();
    
    if (count($this->useCaseResponse->dokumente) > 0) {
      $result .= $this->getDokumenteZeilen();
    } else {
      $result .= $view->getNoData();
    }
    $result .= $view->getFooter();

    return $result;
  }

  private function getDokumenteZeilen()
  {
    $dokumenteMitBereichsname = array_map(function($dokument) {
      $dokument->nameBereich = $dokument->getVarValue('bereichsname');
      if ($dokument->nameBereich == '') {
        $dokument->nameBereich = 'Allgemein';
      }

      return $dokument;
    }, $this->useCaseResponse->dokumente);
    $dokumenteNachBereichsname = \ArrayOperations::setAttributAsKeyArray($dokumenteMitBereichsname, 'nameBereich');
    ksort($dokumenteNachBereichsname);

    $result = '';
    foreach ($dokumenteNachBereichsname as $bereichsname => $dokumente) {
      $view = $this->getDokumenteZeilenView($bereichsname, $dokumente);
      $result .= $view->getHeader();
      $result .= $view->getBody();
      $result .= $view->getFooter();
    }

    return $result;
  }

  protected function getDokumenteZeilenView($bereichsname, $dokumente)
  {
    $viewModel = new MitarbeiterDokumenteZeilenViewModel();
    $viewModel->dokumente = $dokumente;
    $viewModel->bereichsname = $bereichsname;
    $viewModel->showUploadButton = $this->useCaseResponse->showUploadButton;
    $viewModel->tnr = $this->useCaseResponse->teilnehmer->id;

    return new MitarbeiterDokumenteZeilenView($viewModel);
  }
}